package org.hibernate.bugs;

import org.hibernate.bugs.entity.Person;
import org.hibernate.bugs.entity.Person_;
import org.hibernate.bugs.entity.Subject;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaUpdate;

public class JPAUnitTestCase {

	private EntityManagerFactory entityManagerFactory;

	@Before
	public void init() {
		entityManagerFactory = Persistence.createEntityManagerFactory("templatePU");
	}

	@After
	public void destroy() {
		entityManagerFactory.close();
	}

	@Test
	public void couldNotConvertJavaType() {
		EntityManager entityManager = entityManagerFactory.createEntityManager();
		entityManager.getTransaction().begin();

		CriteriaBuilder builder = entityManager.getCriteriaBuilder();
		CriteriaUpdate<Person> upd = builder.createCriteriaUpdate(Person.class);
		upd.from(Person.class);
		upd.set(Person_.subject, builder.nullLiteral(Subject.class));

		entityManager.createQuery(upd).executeUpdate();

		entityManager.getTransaction().commit();
		entityManager.close();
	}
}
